
var fs = require("fs")
var path = require("path")
var crypto = require("crypto")
//数组的扩展
Array.prototype.where = function (fn) {
    var rs = [];
    for (var i = 0; i < this.length; i++) {
        if (fn(this[i]) == true) {
            rs[rs.length] = this[i];
        }
    }
    return rs;
}

//fn是比较函数，有一个参数就是item和i,返回值有true和false
Array.prototype.del = function (fn) {
    var rs = [];
    for (var i = 0; i < this.length; i++) {
        if (fn(this[i], i) == false) {
            rs[rs.length] = this[i];
        }
    }
    this.length = rs.length;
    for (var i = 0; i < this.length; i++) {
        this[i] = rs[i];
    }
}

//whereFn是比较函数，有一个参数就是item和i,返回值有true和false
//updateFn是更新函数，当whereFn为true时，把这个item更新为什么.参数也是item和i
Array.prototype.update = function (whereFn, updateFn) {
    for (var i = 0; i < this.length; i++) {
        if (whereFn(this[i], i) == true) {
            updateFn(this[i], i);
        }
    }

};
//跳过
Array.prototype.skip = function (num) {
    if (num >= this.length) return [];
    var rs = [];
    for (var i = num; i < this.length; i++) {
        rs[rs.length] = this[i];
    }
    return rs;
}
//获取
Array.prototype.take = function (num) {
    var rs = [];
    for (var i = 0; i < num; i++) {
        var item = this[i];
        if (!item) continue;
        rs[rs.length] = item;
    }
    return rs;
}


//获取
Array.prototype.orderby = function (key) {
    this.sort(function (a, b) {
        if (a[key] == b[key]) return 0;
        if (a[key] > b[key]) return 1;
        if (a[key] < b[key]) return -1;
    });
    return this;
}
//获取
Array.prototype.orderbydesc = function (key) {
    this.sort(function (a, b) {
        if (a[key] == b[key]) return 0;
        if (a[key] > b[key]) return 1;
        if (a[key] < b[key]) return -1;
    });
    return this;
}

Array.prototype.last = function () {
    return this[this.length - 1];
}

//获取
Array.prototype.select = function (fn) {
    var rs = [];
    for (var i = 0; i < this.length; i++) {
        var item = fn(this[i]);
        rs[rs.length] = item;
    }
    return rs;
}

Array.prototype.sum = function (func) {
    var val;
    for (var i = 0; i < this.length; i++) {
        if (!val) val = func(this[i]);
        else {
            val += func(this[i]);
        }
    }
    return val;
}

Array.prototype.have = function (fn) {
    if (typeof fn == "string") {
        return this.indexOf(fn) >= 0;
    } else {
        return this.where(fn).length > 0;
    }

}



//日期运算
Date.prototype.format = function (format) {
    if (!isNaN(this.valueOf())) {

        if (typeof (format) != "string") return this.toLocalString();
        var year = this.getFullYear().toString();
        var month = (this.getMonth() + 1).toString();;
        var date = this.getDate().toString();;
        var hour = this.getHours().toString();
        var minutes = this.getMinutes().toString();
        var sencond = this.getSeconds().toString();
        var ms = this.getMilliseconds().toString();
        format = format.replace("yyyy", year);
        format = format.replace("MM", month.length == 1 ? "0" + month : month);
        format = format.replace("dd", date.length == 1 ? "0" + date : date);
        format = format.replace("HH", hour.length == 1 ? "0" + hour : hour);
        format = format.replace("mm", minutes.length == 1 ? "0" + minutes : minutes);
        format = format.replace("ss", sencond.length == 1 ? "0" + sencond : sencond);
        format = format.replace("ff", ms.length == 1 ? "000" + ms : ms.length == 2 ? "00" + ms : ms.length == 3 ? "0" + ms : ms);
        format = format.replace("yy", year[2] + year[3]);
        format = format.replace("M", month);
        format = format.replace("d", date);
        format = format.replace("h", hour);
        format = format.replace("m", minutes);
        format = format.replace("s", sencond);
        format = format.replace("f", ms);
        return format;
    } else {
        return "";
    }

};


Date.parseString = function (datestr, split) {
    if (!split) split = "-";
    var arr = datestr.split(" ");
    if (!arr || arr.length <= 0) return;
    var dateArr = arr[0].split(split);
    var timeArr = !arr[1] ? [] : arr[1].split(":");

    if (!dateArr || !timeArr || dateArr.length < 3) return;
    var year = parseInt(dateArr[0]);
    var month = parseInt(dateArr[1]) - 1;
    var day = parseInt(dateArr[2]);
    var hour = timeArr && timeArr.length >= 1 ? parseInt(timeArr[0]) : 0;
    var minutes = timeArr && timeArr.length >= 2 ? parseInt(timeArr[1]) : 0;
    var second = timeArr && timeArr.length >= 3 ? parseInt(timeArr[2]) : 0;
    return new Date(year, month, day, hour, minutes, second);
};

Date.prototype.addTime = function (time) {
    return new Date(this.getTime() + time);
};



class Helper {


    getClientIP_call() {
        var ips = this.headers["x-forwarded-for"] && this.headers["x-forwarded-for"].trim().split(",");
        var ip = ips && ips.length > 0 && ips[0];
        if (!ip) ip = this.request.headers["x-real-ip"];
        if (!ip) ip = "0.0.0.0";
        return ip;
    }

    get_all_files(dir, ignores = []) {
        var rs = fs.readdirSync(dir);
        rs = rs.select(t => path.join(dir, t)).where(t => ignores.select(d => path.join(dir, d)).have(t) == false);
        var dirs = rs.where(t => fs.lstatSync(t).isDirectory());
        var files = rs.where(t => fs.lstatSync(t).isDirectory() == false);
        var child_files = dirs.select(t => this.get_all_files(t));
        child_files.select(t => files = files.concat(t));
        return files;
    }

    async  sign_file(file_path, key) {
        let file_md5 = await this.get_file_md5(file_path);
        return this.md5(file_md5 + "&" + key);


    }

    async get_file_md5(file_path) {
        if (!file_path || fs.existsSync(file_path) == false) return "";
        var ctx = this;
        return new Promise((resolve, reject) => {
            var md5sum = crypto.createHash('md5');
            var stream = fs.createReadStream(file_path);
            stream.on('data', function (chunk) {
                md5sum.update(chunk);
            });
            stream.on('end', function () {
                var str = md5sum.digest('hex').toUpperCase();
                resolve(str);
            });
            stream.on("error", function (err) {
                reject(err);
            })
        });
    }
    md5(str) {
        var md5sum = crypto.createHash('md5');
        md5sum.update(str);
        return md5sum.digest('hex').toUpperCase();
    }

    md5_sign(obj, key) {
        var arr = [];
        for (var item in obj) {
            if (!obj[item]) continue;
            arr[arr.length] = `${item}=${obj[item]}`
        }
        arr = arr.sort();
        var str = arr.join("&");
        str += ("&key=" + key);
        var hmac = crypto.createHash('md5');
        hmac.update(str, "utf8");
        return hmac.digest('hex').toUpperCase();
    }

    async sign_receiver(data, file_path, key) {
        let sign_data = { ...data };
        sign_data.file = await this.get_file_md5(file_path);
        return this.md5_sign(sign_data, key);
    }
    normal_path(file_path) {
        if (!file_path) return file_path;
        return file_path.replace(new RegExp("\\\\", "g"), path.sep);

    }

    get_arg_value(arg_name) {
        var args = process.argv;
        if (!args || !arg_name) return;

        var idx = args.indexOf(arg_name);
        if (idx < 0) return;

        return args[idx + 1];
    }

    is_have_arg(arg_name) {
        var args = process.argv;
        if (!args || !arg_name) return false;
        return args.indexOf(arg_name) >= 0;
    }


}



module.exports = new Helper();